#!/usr/bin/perl 
#
# Gestionnaire de pages linux
# Linux Home Page Lister
#
#
# (c) 1999 Emmanuel PIERRE
#          epierre@e-nef.com
#          http://www.e-nef.com/users/Emmanuel.PIERRE
#
# $Log: index.cgi,v $
# Revision 1.1  1999/05/29 10:10:10  epierre
# Revision 1.2  2000/10/03 pjones
# Revision 1.3  2000/10/03 pjones
# Revision 1.4  2001/05/15 epierre
#
$version="Revision: 1.4 Date: 2001/05/15";

require 5.002;
use strict;
use Carp;


BEGIN { $ENV{PATH} = '/usr/bin:/bin' }

require "web_ui_define.pl";

my $prog="lxusers.cgi";

my $hostname=`/bin/hostname`;

my $server_name = "http://$hostname";

#
# Du HTML
#

&PrintHeader($hostname);

#
# pages locales
#
my (%hash,$user,$url,$real,$photo,$tab_html);

&get_pages;

#
# trie les informations
#
for (sort by_name keys %hash) {
	($user,$url,$real,$photo)= split(/\t/,$hash{$_});
	$tab_html = "<TR>\n";
	$tab_html .= "\t<TD><A HREF=\"$url\"><IMG SRC=\"$photo\" align=absmiddle height=$main::PhotoHeight width=$main::PhotoWidth border=0></TD>\n";
	$tab_html .= "\t<th align=right><A HREF=\"$url\"><font size=5>$user</font></A></th>\n";
	$tab_html .= "\t<TD><LI></TD>\n";
	$tab_html .= "\t<TD><A HREF=\"$url\"><font size=5>$real</font></A></TD>\n";
	$tab_html .= "</TR>\n";
	print "$tab_html";
};

#
# et on affiche
#


print "</TABLE>\n";

&PrintFooter;

exit;

#
# Routine de tri
#
sub by_name  {
        $a cmp $b
}

#
# Pages locales
#
sub get_pages {

	my ($lu,$user,$uid,$gcos,$dir,@tliste);

        # Read the real name from passwd file

        open(PW,"/bin/ypcat passwd |");
        while ($lu=<PW>) {
                chomp($lu);
                ($user,$_,$uid,$_,$gcos,$dir) = split(/:/,$lu);
                ($real) = split(/,/, $gcos);
                if ($uid>10) {
                        push @tliste, $user.":".$real.":".$dir."\n";
                }
        }
        close(PW);
        open(PW,"/etc/passwd");
        while ($lu=<PW>) {
                chomp($lu);
                ($user,$_,$uid,$_,$gcos,$dir) = split(/:/,$lu);
                ($real) = split(/,/, $gcos);
                if ($uid>10) {
                        push @tliste, $user.":".$real.":".$dir."\n";
                }
        }
        close(PW);

        @tliste = sort @tliste;
        @tliste = reverse @tliste;

        while (@tliste) {
                ($user,$real,$dir)=split(/:/,pop @tliste);
                chomp($dir);
		$url="";
		$photo="";

		# Si on redirige vers une page externe
		if (-r $dir."/.weblxredirect") {
			open(FIC,$dir."/.weblxredirect");
                       	$url=<FIC>;
                       	$photo=<FIC>;
       	               	close(FIC);	
			chomp($url);
		} else {
			# Si on a une page personnelle
			if (-r $dir."/public_html/index.html") {
				$url="$server_name/~$user/index.html";
			}
                        if (-r $dir."/public_html/index.shtml") {
                                $url="$server_name/~$user/index.shtml";
                        } 
                        if (-r $dir."/public_html/index.php") {
                                $url="$server_name/~$user/index.php";  
                        }
                        if (-r $dir."/public_html/index.cgi") {
                                $url="$server_name/~$user/index.cgi";  
                        }
                        if (-r $dir."/public_html/index.htm") {
                                $url="$server_name/~$user/index.htm";  
                        }
                        if (-r $dir."/public_html/default.htm") {
                                $url="$server_name/~$user/default.htm";  
                        }

		}
		# La photo en GIF ou JPEG
		if (-r $dir."/public_html/photo.gif") {
                	$photo="$server_name/~$user/photo.gif";
                }
		if (-r $dir."/public_html/photo.jpg") {
                	$photo="$server_name/~$user/photo.jpg";
                }
		# Si il n'y en a pas, une par dfaut
		if ($photo eq "") {
			$photo="/web_ui/$main::PhotoFileName";
		}
		# C'est bon, alors on stocke
		if ($url ne "") {
               		$hash{$user}="$user\t$url\t$real\t$photo\n";
			#print "2-$hash{$user}";
		}

	}	
}
